Subject: Re: why all packets have same queue no when rps enabled?

From: Ben Hutchings <[email-masked]>
Date: Tue, 22 Feb 2011 13:09:25 +0000

On Tue, 2011-02-22 at 14:01 +0100, Eric Dumazet wrote:
> Le mardi 22 février 2011 à 12:45 +0000, Ben Hutchings a écrit :
> 
> > The queue number identifies a hardware queue.  RPS therefore does not
> > update this number when queueing packets for processing on other CPUs.
> > 
> > If the hardware/driver provides a receive hash (probably Toeplitz) then
> > this is used for RPS.  Otherwise a much cheaper hash is used.
> 
> The default is/should be : rxhash generated in network stack.
> 
> ethtool -k eth0 | grep hash
> receive-hashing: off
> 
> To use the device/harwdare provided rxhash, you need to ask for it.
> 
> ethtool -K eth0 rxhash on

Whether this is enabled by default depends on the driver.

> BTW, I am not sure what you mean by "much cheaper hash is used"...
> 
> I presume hardware provided hash is less expensive (for our cpu) than
> computing our rxhash...

I mean the hash function we use is much cheaper than Toeplitz.

Ben.

-- 
Ben Hutchings, Senior Software Engineer, Solarflare Communications
Not speaking for my employer; that's the marketing department's job.
They asked us to note that Solarflare product names are trademarked.